'use strict';
/** @jsx createElement */
import {Component, PropTypes,unmountComponentAtNode } from 'weex-rx';
import Picker from './actionsheet';
import {mount} from 'nuke-mounter';
const noop = () => {};

class PickerWrap extends Component {

    shouldComponentUpdate(nextProps, nextState) {
        return !!(this.props.visible || nextProps.visible);
    }

    componentDidMount() {
        this.componentDidUpdate();
    }

    componentDidUpdate() {
        if (this.inited) {
            // render for context and animation
            // 
            mount(this,
                this.getDialogEl(), this.getContainerEl());
        }
    }

    componentWillUnmount() {

        if (!this.containerEl) {
            return;
        }

        if (this.props.visible) {
            // close(re-render) for animation
            mount(this, this.getDialogEl({
                visible: false,
                onClose: noop,
                afterClose: () => { this.cleanContainerEl() }
            }), this.getContainerEl());
        } else {
            this.cleanContainerEl();
        }
    }

    getDialogEl(props) {

        props = {...this.props, ...props};

        return <Dialog {...props} />
    }

    getContainerEl() {
        let containerEl = this.containerEl;
        debugger;
        if (!containerEl) {
            containerEl = document.createElement('div');
            document.body.appendChild(containerEl);

            this.containerEl = containerEl;
        }

        return containerEl;
    }

    cleanContainerEl() {
        let containerEl = this.containerEl;

        if (containerEl) {
            unmountComponentAtNode(containerEl);
            document.body.removeChild(containerEl);
            this.containerEl = null;
        }
    }

    render() {
        this.inited = this.inited || this.props.visible || this.props.defaultVisible;
        return null;
    }
}

export default PickerWrap;
